//+------------------------------------------------------------------+
//|                                            ChandeQStick_v1.1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    LightBlue
#property indicator_width1    1
#property indicator_level1    0

//---- input parameters
extern int       Length   =  8; // Period of evaluation
extern int       MA_Mode  =  0; // MA mode : 0-SMA,1-EMA,2-SMMA,3-LWMA

//---- buffers
double CQS[];
double Diff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,CQS);
   SetIndexBuffer(1,Diff);
//---- name for DataWindow and indicator subwindow label
   string short_name="ChandeQStick("+Length+","+MA_Mode+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"CQS");
//----
   SetIndexDrawBegin(0,Length);

   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int      shift, limit, counted_bars=IndicatorCounted();
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for( shift=limit; shift>=0; shift--)
   Diff[shift] = Close[shift]-Open[shift];
   
   for( shift=limit; shift>=0; shift--)
   CQS[shift] = iMAOnArray(Diff,0,Length,0,MA_Mode,shift); 

//----
   return(0);
  }
//+------------------------------------------------------------------+